#include "abstractmodeltablewidget.h"
#include <QVBoxLayout>
#include <QAction>
#include <QSqlQuery>
#include <QDebug>
AbstractModelTableWidget::AbstractModelTableWidget(QWidget *parent) :
        QWidget(parent)
{


    mToolBar = new QToolBar;
    mTreeView= new QTreeView;
    mLineEdit=  new QLineEdit;
    mComboBox = new QComboBox;

    mTreeView->setRootIsDecorated(false);
    mTreeView->setAlternatingRowColors(true);

    QVBoxLayout * layout = new QVBoxLayout;
    QAction * addAction =new QAction(QIcon(":/icons/small/add.png"),"add",this);
    QAction * editAction =new QAction(QIcon(":/icons/small/edit.png"),"edit",this);
    QAction * delAction=new QAction(QIcon(":/icons/small/delete.png"),"delete",this);
    QAction * refreshAction=new QAction(QIcon(":/icons/small/refresh.png"),"refresh",this);

    mToolBar->addAction(addAction);
    mToolBar->addAction(editAction);
    mToolBar->addAction(delAction);
    mToolBar->addAction(refreshAction);


    mToolBar->addSeparator();
    mToolBar->addWidget(mLineEdit);
    mToolBar->addWidget(mComboBox);


    layout->addWidget(mToolBar);
    layout->addWidget(mTreeView);

    setLayout(layout);

    connect(addAction,SIGNAL(triggered()),this,SLOT(addRecord()));
    connect(editAction,SIGNAL(triggered()),this,SLOT(editRecord()));
    connect(delAction,SIGNAL(triggered()),this,SLOT(deleteRecord()));
    connect(refreshAction,SIGNAL(triggered()),this,SLOT(refresh()));


}
void AbstractModelTableWidget::setModel(QSqlQueryModel * model)
{
    mTreeView->setModel(model);
}

void AbstractModelTableWidget::refresh()
{
    QSqlQueryModel * model = qobject_cast<QSqlQueryModel*> (mTreeView->model());
    model->setQuery(model->query().lastQuery());
}
