#include "sqlhelper.h"
#include <QDebug>
#include <QSqlQueryModel>
SqlHelper::SqlHelper(QString table,QObject*parent)
    :QObject(parent)
{

    mTable = table;
}
//==============Object Method ================

bool SqlHelper::insertRecord(QSqlRecord record)
{
    return insertRecord(mTable,record);
}

bool SqlHelper::deleteRecord(int modelId)
{
    return deleteRecord(mTable,modelId);
}

bool SqlHelper::deleteRecord(QString condition)
{
    return deleteRecord(mTable,condition);
}

bool SqlHelper::updateRecord(QSqlRecord record)
{
    return updateRecord(mTable,record);
}

QSqlRecord SqlHelper::record(int modelId)
{
    return record(mTable,modelId);
}

QSqlRecord SqlHelper::emptyRecord()
{
    return emptyRecord(mTable);
}

int SqlHelper::lastInsertId()
{
    return lastInsertId(mTable);
}

bool SqlHelper::saveRecord(QSqlRecord record)
{
    return saveRecord(mTable,record);
}


//==============Static Method=================


bool SqlHelper::insertRecord(QString table, QSqlRecord record)
{

    QString fields;
    QString values;

    record.setValue("id", QVariant(lastInsertId(table)+1));

    for ( int i =0; i<record.count(); ++i)
    {

        fields+=record.fieldName(i)+",";
        values+="'"+record.value(record.fieldName(i)).toString()+"' ,";

    }

    fields.remove(fields.length() - 1,1);
    values.remove(values.length() - 1,1);


    QString requete = "INSERT INTO "+table+"  ("+fields+") VALUES ("+values+")";
    qDebug()<<requete;
    QSqlQuery query;
    if (!query.exec(requete))
    {
        qDebug()<<query.lastError().text();
        return false;
    }
    return true;

}

bool SqlHelper::deleteRecord(QString table, int modelId)
{
    QSqlQuery query
            ("delete from "+table+" WHERE id ='"+QString::number(modelId)+"'");
    if (!query.exec())
    {
        qDebug()<<query.lastError().text();
        return false;
    }
    return true;
}
bool SqlHelper::deleteRecord(QString table, QString condition)
{
    QSqlQuery query
            ("delete from "+table+" WHERE "+condition);
    if (!query.exec())
    {
        qDebug()<<query.lastError().text();
        return false;
    }
    return true;
}
bool SqlHelper::updateRecord(QString table, QSqlRecord record)
{
    QString part="";
    for ( int i =0; i<record.count(); ++i)
        part+=record.fieldName(i)+"=:"+record.fieldName(i)+",";

    part.remove(part.size()-1,1);
    QString requete = "UPDATE "+table+" SET "+part+" WHERE id='"+record.value("id").toString()+"'";
    QSqlQuery query;
    query.prepare(requete);
    for ( int i =0; i<record.count(); ++i)
    {
        query.bindValue(i, record.value(i));
    }

    if ( !query.exec())
    {
        qDebug()<<query.lastError().text();
        return false;
    }
    return true;
}
QSqlRecord SqlHelper::record(QString table, int modelId)
{

    QSqlQuery query("select * from "+table+" WHERE id='"+QString::number(modelId)+"'");
    query.seek(0);
    return query.record();

}
QSqlRecord SqlHelper::emptyRecord(QString table)
{
    QSqlQuery query("select * from "+table);
    query.seek(0);
    QSqlRecord record = query.record();
    record.clearValues();

    return record;
}
int SqlHelper::lastInsertId(QString table)
{
    QSqlQuery query("SELECT MAX(id) AS lastId FROM "+table);
    query.next();
    return query.record().value(0).toInt();


}
bool SqlHelper::saveRecord(QString table, QSqlRecord record)
{
    QSqlQueryModel *model = new QSqlQueryModel();
    model->setQuery("SELECT * from "+table+" where id='"+record.value("id").toString()+"'");
    if (model->rowCount()>0)
        return updateRecord(table,record);

    else
        return insertRecord(table,record);


}
