


#include "ktblockitem.h"
 #include <QGraphicsSceneMouseEvent>
#include <QDebug>
#include <KMenu>
#include <KStandardAction>

//=================================================================
KTBlockItem::KTBlockItem(QGraphicsItem * parent ):QGraphicsRectItem(parent)
{

setFlags(QGraphicsItem::ItemIsMovable|QGraphicsItem::ItemIsSelectable);
setAcceptHoverEvents (true);
grabbed = false;
grab    = NO;
setBrush(QColor(255,0,0,50));
name    ="no_name";
}

//================================================================
void KTBlockItem::paint ( QPainter * painter, const QStyleOptionGraphicsItem * option, QWidget * widget ) 
{

QGraphicsRectItem::paint(painter,option,widget);

if ( isSelected () == true)
drawGrapper(painter,option);


}

//=================================================================
void KTBlockItem::drawGrapper(QPainter * painter, const QStyleOptionGraphicsItem * option)
{
int sc = 10;   //size of corner

if ( grab != NO)
{
QString strRes = QString::number(option->rect.width())+"x"+QString::number(option->rect.height());
painter->drawText(option->rect, Qt::AlignCenter, strRes);
}
painter->setBrush(QColor(0,255,0,50));
painter->drawRect(option->rect.x(),option->rect.y(),option->rect.width(),10 );
painter->drawRect(option->rect.x(),option->rect.y()+option->rect.height(),option->rect.width(),-10 );

painter->drawRect(option->rect.x(),option->rect.y(),10,option->rect.height());
painter->drawRect(option->rect.x()+option->rect.width(),option->rect.y(),-10,option->rect.height());
}
//=====================================================================
void KTBlockItem::mouseMoveEvent ( QGraphicsSceneMouseEvent * event )
{

//resize!
switch ( grab)
{
case NO : QGraphicsRectItem::mouseMoveEvent(event); return;

case HD : setRect(rect().x(), rect().y(), rect().width(), event->pos().y()-rect().y());
	  break;

case HU : setRect(rect().x(), event->pos().y(), rect().width(), rect().height()+(rect().y()-event->pos().y()));
	  break;

case VR : setRect(rect().x(), rect().y(),event->pos().x()-rect().x(), rect().height());
	  break;

case VL : setRect(event->pos().x(),rect().y(), rect().width()+(rect().x()-event->pos().x()), rect().height());
	  break;


case CDR :setRect(rect().x(),rect().y(),event->pos().x()-rect().x(), event->pos().y()-rect().y());
	  break; 

case CUR :setRect(rect().x(),event->pos().y(),event->pos().x()-rect().x(), rect().height()+(rect().y()-event->pos().y()));
	  break;

case CDL :setRect(event->pos().x(),rect().y(),rect().width()+(rect().x()-event->pos().x()), event->pos().y()-rect().y());
	  break; 

case CUL :setRect(event->pos().x(), event->pos().y(), rect().width()+(rect().x()-event->pos().x()), rect().height()+(rect().y()-event->pos().y()));
	  break; 

}

update();



}
//===========================================================================
void KTBlockItem::hoverMoveEvent ( QGraphicsSceneHoverEvent * event )
{

grab = getCorner(event->pos());

if ( (grab == CUL) || (grab == CDR))
setCursor(Qt::SizeFDiagCursor);

if ( (grab == CUR) || (grab == CDL))
setCursor(Qt::SizeBDiagCursor);

if ( (grab == HU) || (grab == HD))
setCursor(Qt::SizeVerCursor);

if ( (grab == VL) || (grab == VR))
setCursor(Qt::SizeHorCursor);

if ( grab == NO)
setCursor(Qt::ArrowCursor);




QGraphicsRectItem::hoverEnterEvent(event);


}
//=====================================================================
   void KTBlockItem::contextMenuEvent(QGraphicsSceneContextMenuEvent *event)
         {
             KMenu menu("The Box");
	   
menu.addAction(name); 	
             
      
menu.exec(event->screenPos());
             
         }


//====================================================================
corner KTBlockItem::getCorner( QPointF mouse)
{

double x = rect().x();
double y = rect().y();
double h = rect().height();
double w = rect().width();

QRectF cul (x,y, 10,10);
QRectF cur (x+w-10,y, 10,10);
QRectF cdl (x,y+h-10,10,10);
QRectF cdr (x+w-10,y+h-10,10,10);

QRectF hu (x+10,y,w-20,10);
QRectF hd (x+10,y+h-10,w-20,10);
QRectF vl (x,y+10,10,h-20);
QRectF vr (x+w-10,y+10,10,h-20);

if ( cul.contains(mouse) ) return CUL;
if ( cur.contains(mouse) ) return CUR;
if ( cdl.contains(mouse) ) return CDL;
if ( cdr.contains(mouse) ) return CDR;
if ( hu.contains(mouse) ) return HU;
if ( hd.contains(mouse) ) return HD;
if ( vl.contains(mouse) ) return VL;
if ( vr.contains(mouse) ) return VR;

return NO;
}

//==========================================================================
